<script setup>
import AppLayout from '@/Layouts/AppLayoutWater.vue';
import Welcome from '@/Jetstream/Welcome.vue';
import { Link } from '@inertiajs/inertia-vue3';

</script>

<style>
table {
    border-color: transparent !important;
}

table.dataTable thead .sorting {
    background-image: none !important;
}

table.dataTable thead .sorting_asc,
table.dataTable thead .sorting_desc {
    background-image: none !important;
    color: white !important;
    font-weight: 600 !important;
}

.dataTables_wrapper {
    margin-bottom: 0.5rem !important;
}

.dataTables_wrapper .dataTables_paginate .paginate_button.disabled,
.dataTables_wrapper .dataTables_paginate .paginate_button.disabled:hover,
.dataTables_wrapper .dataTables_paginate .paginate_button.disabled:active {
    cursor: default;
    color: rgba(200, 200, 200, 0.9) !important;
    border: 1px solid transparent;
    background: transparent;
    box-shadow: none;
}

.dataTables_wrapper .dataTables_paginate .paginate_button {
    box-sizing: border-box;
    display: inline-block;
    min-width: 1.5em;
    padding: 0.5em 1em;
    margin-left: 2px;
    text-align: center;
    text-decoration: none !important;
    cursor: pointer;
    cursor: hand;
    color: rgba(200, 200, 200, 0.9) !important;
    border: 0;
    border-radius: 0.375rem;
}

.dataTables_wrapper .dataTables_paginate .paginate_button:hover {
    color: rgba(200, 200, 200, 1) !important;
    background-color: rgba(0, 152, 219, 0.1) !important;
    background-image: unset !important;
    border: 0;
}

.dataTables_wrapper .dataTables_paginate .paginate_button.current,
.dataTables_wrapper .dataTables_paginate .paginate_button.current:hover {
    color: rgba(255, 250, 250, 1) !important;
    border: 0 !important;
    background-color: rgba(0, 152, 219, 0.2) !important;
    background-image: unset !important;
    border-bottom-width: 2px;
    border-bottom-color: rgba(255, 250, 250, 1);
    border-radius: 0.375rem;
}

.dataTable thead th,
.dataTable thead td {
    padding-top: 0 !important;
    padding-bottom: 0 !important;
}

table.dataTable thead th,
table.dataTable thead td {
    padding: 0px 10px;
    font-size: 0.9rem !important;
    border-bottom: 1px solid rgba(200, 200, 200, 0.75) !important;
}
</style>

<template>
    <AppLayout title="Devices">
        <loader-component></loader-component>
        <div v-if="this.screen_width >= 768" style="height: calc(100vh - 4.75rem);" class="bg-darkblue-background p-8 z-0 cursor-default">
            <div class="mt-3 pt-6 pb-3 px-10 baltoro-container">
                <p class="text-white-snow font-light text-2xl w-full text-left">{{ this.device_group[0].group_name }}</p>

                <table id="basicTable" class="row-border">
                    <thead class="bg-transparent text-gray-light my-2">
                        <tr>
                            <th>{{ this.$t("general.GatewayID") }}</th>
                            <th>{{ this.$t("general.Version") }}</th>
                            <th>{{ this.$t("general.Name") }}</th>
                            <th>{{ this.$t("general.Service") }}</th>
                            <th>{{ this.$t("general.Sector") }}</th>
                            <th class="w-24">{{ this.$t("general.Readings") }}</th>
                            <th class="w-24">{{ this.$t("general.Profile") }}</th>
                            <th class="w-24">{{ this.$t("general.Transients") }}</th>
                            <th class="w-5"></th>
                        </tr>
                    </thead>
                    <tbody class="text-center">
                        <tr class="items-center" v-for="(data, index) in this.device_group" :key="index"
                            v-bind:class="{ 'bg-transparent': !(this.hasAlert(this.device_group[index].id)), 'bg-yellow-alert-opa hover:bg-yellow-alert-opa-hover': this.hasAlert(this.device_group[index].id) }">
                            <td>{{ this.device_group[index].id }}</td>
                            <td>{{ this.device_group[index].type_name }}</td>
                            <td>{{ this.device_group[index].name }}</td>
                            <td>
                                <div class="flex justify-center items-center rounded-md text-white-snow font-light text-base">
                                    <p :style="{ 'background-color': this.device_group[index].service_color }"
                                        class="service-label">
                                        {{ this.device_group[index].service_tag }}
                                    </p>
                                </div>
                            </td>
                            <td>
                                <!--<div v-for="(data, index) in JSON.parse(this.device_group[index].sectors)" :key="index" class="inline-flex">
                                        <div class="flex rounded-md  text-white-snow font-light text-base">
                                            <p class="sector-label">
                                                {{data["name"]}}
                                            </p>
                                        </div>
                                    </div>-->
                                <div class="flex justify-center items-center rounded-md  text-white-snow font-light text-base gap-x-2">
                                    <div v-for="(data_s, index_s) in JSON.parse(this.device_group[index].sectors)"
                                        :key="index_s" class="inline-flex">
                                        <div v-for="(data_g, index_g) in this.group_sector" :key="index_g"
                                            class="inline-flex rounded-md text-white-snow font-light text-base">
                                            <p v-if="index_s == this.group_sector[index_g].id" class="sector-label">
                                                {{ data_g.tag }}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </td>
                            <!--<td class="inline-flex justify-center gap-2 w-full">
                                    <div v-for="(data, index) in JSON.parse(this.device_group[index].sectors)" :key="index" class="mt-1 text-md text-white-snow font-light">                            
                                        <p v-bind:class='{ "bg-sector1-TAG": data["name"] == "Sector 1","bg-sector2-TAG": data["name"] == "Sector 2","bg-sector3-TAG": data["name"] == "Sector 3", "bg-sector4-TAG": data["name"] == "Sector 4", "bg-sector5-TAG": data["name"] == "Sector 5" }' class="rounded-md shadow-lg inline-flex justify-center rounded-md  text-gray-light px-1 py-1 font-light cursor-pointer	">
                                            {{data["name"]}}
                                        </p>                                                                  
                                    </div>
                                </td>-->
                            <td class="w-fit">
                                <div class="flex items-center justify-center px-1 py-0.5 w-full">
                                    <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_Readings', { id:  this.device_group[index].id })" >
                                        <button type="button"
                                            class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                            <i class="fa-solid fa-chart-column" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                        </button>
                                    </Link>
                                </div>
                            </td>
                            <td class="w-fit">
                                <div class="flex items-center justify-center px-1 py-0.5 w-full" id="btnProfile">
                                    <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('meterProfile', { id:  this.device_group[index].id })" >
                                        <button type="button"
                                            class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                            <i class="fa-solid fa-gears" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                        </button>
                                    </Link>
                                </div>
                            </td>
                            <td v-if="this.pres_transients.includes(index)" class="w-fit">
                                <div class="flex items-center justify-center px-1 py-0.5 w-full" id="btnPressureTransients">
                                    <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_PressureTransients', { id:  this.device_group[index].id })" >
                                        <button type="button"
                                            class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                            <i class="DK-presion" style="font-size:0.875rem; color:#FFFAFA; margin-right:0rem;  margin-left:0rem; position:relative; top:0%"></i>
                                        </button>
                                    </Link>
                                </div>
                            </td>
                            <td v-else></td>
                            <td class="w-5" v-if="this.hasAlert(this.device_group[index].id)">
                                <i class="fa-solid fa-triangle-exclamation"
                                    style="font-size:1rem; color:rgba(224,191,52,1);"></i>
                            </td>
                            <td class="w-5" v-else></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <div v-else style="height: calc(100vh - 4.75rem);" class="bg-darkblue-background p-4 z-0 cursor-default flex flex-col gap-4 overflow-hidden">

            <div class="flex justify-start items-center">
                <p class="text-white-snow font-light text-left text-2xl w-full">{{ this.device_group[0].group_name }} </p>
            </div>

            <div class="pt-2 px-4 baltoro-container h-full">
                <table id="basicTable" class="row-border">
                    <thead class="bg-transparent">
                        <tr>
                            <th></th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody class="text-center">
                        <tr class="items-center" v-for="(data, index) in this.device_group" :key="index" v-bind:class="{ 'bg-transparent': !(this.hasAlert(this.device_group[index].id)), 'bg-yellow-alert-opa hover:bg-yellow-alert-opa-hover': this.hasAlert(this.device_group[index].id) }" v-on:click.stop="this.OpenRow(index)">
                            <td>
                                <i class="fa-solid transition duration-100 fa-angle-down" v-bind:class="{'-rotate-90 ' : this.GW_open[index], }" style="font-size:0.9rem; color:rgba(240,240,240,0.8);"></i>
                            </td>

                            <td class="flex flex-row justify-between items-center" v-if="!this.GW_open[index]" >

                                <div class="text-base">{{ this.device_group[index].name }}</div>

                                <div class="flex flex-row justify-center items-center">
                                    <div class="w-fit ">
                                        <div class="flex items-center justify-center px-1 py-0.5 w-full">
                                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_Readings', { id:  this.device_group[index].id })" >
                                                <button type="button"
                                                    class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                                    <i class="fa-solid fa-chart-column" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                                </button>
                                            </Link>
                                        </div>
                                    </div>
                                    <div class="w-fit">
                                        <div class="flex items-center justify-center px-1 py-0.5 w-full" id="btnProfile">
                                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('meterProfile', { id:  this.device_group[index].id })" >
                                                <button type="button"
                                                    class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                                    <i class="fa-solid fa-gears" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                                </button>
                                            </Link>
                                        </div>
                                    </div>
                                    <div v-if="this.pres_transients.includes(index)" class="w-fit">
                                        <div class="flex items-center justify-center px-1 py-0.5 w-full" id="btnPressureTransients">
                                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_PressureTransients', { id:  this.device_group[index].id })" >
                                                <button type="button"
                                                    class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                                    <i class="DK-presion" style="font-size:0.875rem; color:#FFFAFA; margin-right:0rem;  margin-left:0rem; position:relative; top:0%"></i>
                                                </button>
                                            </Link>
                                        </div>
                                    </div>
                                </div>
                            </td>

                            <td v-else>
                                <div class="grid grid-cols-2 place-items-start gap-y-1">

                                    <div class="col-span-2 flex flex-row justify-between items-center w-full mb-1">
                                        <div class="text-gray-light text-base">{{ this.device_group[index].name }}</div>

                                        <div class="flex flex-row justify-center items-center">
                                            <div class="w-fit ">
                                                <div class="flex items-center justify-center px-1 py-0.5 w-full">
                                                    <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_Readings', { id:  this.device_group[index].id })" >
                                                        <button type="button"
                                                            class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                                            <i class="fa-solid fa-chart-column" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                                        </button>
                                                    </Link>
                                                </div>
                                            </div>
                                            <div class="w-fit">
                                                <div class="flex items-center justify-center px-1 py-0.5 w-full" id="btnProfile">
                                                    <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('meterProfile', { id:  this.device_group[index].id })" >
                                                        <button type="button"
                                                            class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                                            <i class="fa-solid fa-gears" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                                        </button>
                                                    </Link>
                                                </div>
                                            </div>
                                            <div v-if="this.pres_transients.includes(index)" class="w-fit">
                                                <div class="flex items-center justify-center px-1 py-0.5 w-full" id="btnPressureTransients">
                                                    <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_PressureTransients', { id:  this.device_group[index].id })" >
                                                        <button type="button"
                                                            class="text-white-snow bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">
                                                            <i class="DK-presion" style="font-size:0.875rem; color:#FFFAFA; margin-right:0rem;  margin-left:0rem; position:relative; top:0%"></i>
                                                        </button>
                                                    </Link>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="text-cyan-text text-xs">{{ this.$t("general.GatewayID") }}</div>
                                    <div>{{ this.device_group[index].id }}</div>

                                    <div class="text-cyan-text text-xs">{{ this.$t("general.Version") }}</div>
                                    <div>{{ this.device_group[index].type_name }}</div>

                                    <div class="text-cyan-text text-xs">{{ this.$t("general.Service") }}</div>
                                    <div class="flex justify-center items-center rounded-md text-white-snow font-light text-base">
                                        <p :style="{ 'background-color': this.device_group[index].service_color }"
                                            class="service-label">
                                            {{ this.device_group[index].service_tag }}
                                        </p>
                                    </div>

                                    <div class="text-cyan-text text-xs">{{ this.$t("general.Sector") }}</div>
                                    <div class="flex justify-center items-center rounded-md text-white-snow font-light text-base gap-x-2">
                                        <div v-for="(data_s, index_s) in JSON.parse(this.device_group[index].sectors)"
                                            :key="index_s" class="inline-flex">
                                            <div v-for="(data_g, index_g) in this.group_sector" :key="index_g"
                                                class="inline-flex rounded-md text-white-snow font-light text-base">
                                                <p v-if="index_s == this.group_sector[index_g].id" class="sector-label">
                                                    {{ data_g.tag }}
                                                </p>
                                            </div>
                                        </div>
                                    </div>
                                    
                                    
                                </div>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </AppLayout>
</template>

<script>
export default {
    data() {
        return {
            screen_width: 0,
            GW_open: new Array(this.device_group.length).fill(false),
        };
    },
    props: ['alerts_log', 'device_group', 'group_sector', 'pres_transients', 'user'],

    beforeCreate: function () {
        localStorage.setItem("Back", "devices");
        this.$i18n.locale = this.user.language

        /*localStorage.setItem("Alerts", 0);

        for(var index = 0; index < this.alerts_log.length; index++){
            if(this.alerts_log[index].read == 0 ){
                localStorage.setItem("Alerts", +localStorage.getItem("Alerts") + 1 );
            }
        }*/
    },

    beforeMount() {
        this.screen_width = window.screen.width;
    },

    mounted() {
        window.emitter.emit('changeLoaderStatus', false, 'orbit')
        // //Start loadder

        this.table = $('#basicTable').DataTable({
            language: {
                url: '/assets/i18n/' + this.user.language + '.json'
            },
            order: (this.screen_width >= 768) ? [[2, "asc"]] : [[1, "asc"]],
            //dom: '<"row"<"col-sm-6"B><"col-sm-6"f>>t<"row"<"col-sm-6"i><"col-sm-6"p>><"clear">',                
            searching: true,//(this.screen_width >= 768) ? true : false,
            //paging: true,
            //pageLength: 10,
            info: true,
            ordering: true,
            scrollY: (this.screen_width >= 768) ? 'calc(100vh - 22.5rem)' : 'calc(100vh - 16.5rem)',
            paging: false,
            "columnDefs": [
                { "orderable": false, "targets":  (this.screen_width >= 768) ? [5, 6] : [], }
            ],
        });

    },

    methods: {

        hasAlert(iddevice) {

            for (var index = 0; index < this.alerts_log.length; index++) {
                if (this.alerts_log[index].iddevice == iddevice && this.alerts_log[index].read == 0) {
                    return true;
                }
            }

            return false;

        },

        OpenRow(index){
            this.GW_open[index] = !this.GW_open[index];
        },

    },
}    
</script>
